import java.io.IOException;
import java.io.PipedInputStream;
import java.io.PipedOutputStream;
import java.util.Scanner;
import model.Direction;
import networking.GameBoardClient;
import networking.GameBoardServer;

public class ServerClientTest {
    public static void main(String args[]) throws IOException{
        final PipedInputStream[] client_in = new PipedInputStream[2];
        final PipedInputStream[] server_in = new PipedInputStream[2];
        final PipedOutputStream[] client_out = new PipedOutputStream[2];
        final PipedOutputStream[] server_out = new PipedOutputStream[2];
        final GameBoardClient[] clients = new GameBoardClient[2];
        final GameBoardServer server;
        
        for (int i = 0; i < 2; i++){
            // Server side in  <-- Client side out
            // Server side out --> Client side in
            client_in[i] = new PipedInputStream();
            client_out[i] = new PipedOutputStream();
            server_in[i] = new PipedInputStream(client_out[i]);
            server_out[i] = new PipedOutputStream(client_in[i]);
        }
        server = new GameBoardServer(200, server_in, server_out);
        server.start();

        // Clients has to start AFTER the server is started, otherwise their
        // constructor will block on their InputStream
        for (int i = 0; i < 2; i++){
            clients[i] = new GameBoardClient(client_in[i], client_out[i], null);
            clients[i].start();
        }
        
        Scanner sc = new Scanner(System.in);
        while (true){
            String s = sc.next();
            if (s.equals("x")){
                break;
            } else if (s.equals("w")){
                clients[0].changePlayerDirection(Direction.UP);
            } else if (s.equals("a")){
                clients[0].changePlayerDirection(Direction.LEFT);
            } else if (s.equals("s")){
                clients[0].changePlayerDirection(Direction.DOWN);
            } else if (s.equals("d")){
                clients[0].changePlayerDirection(Direction.RIGHT);
            } else if (s.equals("i")){
                clients[1].changePlayerDirection(Direction.UP);
            } else if (s.equals("j")){
                clients[1].changePlayerDirection(Direction.LEFT);
            } else if (s.equals("k")){
                clients[1].changePlayerDirection(Direction.DOWN);
            } else if (s.equals("l")){
                clients[1].changePlayerDirection(Direction.RIGHT);
            } else if (s.equals("0")){
                client_in[0].close();
            } else if (s.equals("1")){
                client_in[1].close();
            }
        }
        server.stop();
        clients[0].stop();
        clients[1].stop();
    }
}
